// APRS погодная станция v0.26 на базе модуля ESP8266 NodeMCU made in RA4FHE. Выходной формат данных в APRS WX
//Работа с датчиком BMP280(Давление и температура). Подключаем на хардварный I2C, SCL GPIO_5 SDA_GPIO_4 (D1, D2)
//и подтягиваем эти сигналы к VCC 3.3V через резисторы 4,7-5,1кОм. Сигнал CSB датчика вешаем на VCC 3.3V
//http://infotex58.ru

#include <ESP8266WiFi.h>
#include <ESP8266WiFiMulti.h>
#include <Wire.h>
#include <Adafruit_BMP280.h>


ESP8266WiFiMulti WiFiMulti;
Adafruit_BMP280 bme;

void setup() {
  bme.begin();
    
  WiFiMulti.addAP("Infotex", "12345678"); // Указываем SSID и пароль своего WI-FI роутера
  while (WiFiMulti.run() != WL_CONNECTED)
  {
    delay(500);
  }
}


void loop() {
  const uint16_t port = 14580; // Указываем порт сервера
  const char * host = "194.186.45.251"; // Указываем имя хоста или его IP
  WiFiClient client; // Включаем режим WI-FI клиента
  delay(5000);

  if (!client.connect(host, port)) {
    delay(5000);  // Если приконектились к серверу то едим дальше иначе ждём 5сек
    return;
  }

  client.println("user RA4FHE-2 pass 12345 vers ESP8266_WX 0.26 filter m/1");  // Логинемся на сервер
  delay (250);
  float f = bme.readTemperature();
  float p = bme.readPressure();
  p = p / 10; //Паскали в милибарали
  f = (f * 1.8) + 32; //Цельсий в фаренгейт
  

  client.print("RA4FHE-2>APRS,TCPIP*,qAC,T2RUSSIA:=5312.66N/04500.72E_");     // Поехали кидать инфу на сервак
  client.print(".../...g...");
  if (f >= 0)
  {
    client.print("t0"); client.print(f , 0);
  }
  else
  {
    client.print("t"); client.print(f , 0);
  }
  client.print("r...p...P...h..");
  
  if (p >= 10000)
  {
    client.print("b"); client.print(p , 0);
  }
  else
  {
    client.print("b0"); client.print(p , 0);
  }
  client.println(" NodeMCU APRS/WX");
  delay (20000);
  client.println("RA4FHE-2>APRS,TCPIP*,qAC,T2RUSSIA:> Test BMP280 Sensor http://infotex58.ru"); // Статус сообщение
  delay(600000); // Ждём 10 мин перед следующей отправкой пакета 
}
